---
- name: Mount GitLab NFS
  mount:
    fstype: nfs
    opts: defaults,nofail,lookupcache=positive
    state: mounted
    src: "{{ gitlab_nfs_int_ip }}:{{ gitlab_nfs_path }}"
    path: "{{ gitlab_nfs_path }}"
  tags: nfs

- name: Update Ulimit Open Files
  pam_limits:
    domain: '*'
    limit_type: '-'
    limit_item: nofile
    value: '10240'
  tags: ulimit

- name: Setup GitLab config file
  template:
    src: templates/pgbouncer.gitlab.rb.j2
    dest: /etc/gitlab/gitlab.rb
  tags: reconfigure

- name: Check if custom config exists
  stat:
    path: "{{ pgbouncer_custom_config_file }}"
  delegate_to: localhost
  become: false
  tags: reconfigure
  register: pgbouncer_custom_config_file_path

- name: Setup custom GitLab config file
  template:
    src: "{{ pgbouncer_custom_config_file }}"
    dest: "/etc/gitlab/gitlab.pgbouncer.custom.rb"
    mode: 0644
  tags: reconfigure
  when: pgbouncer_custom_config_file_path.stat.exists

- name: Copy secrets file from NFS
  shell: "cp {{ gitlab_nfs_path }}/gitlab-secrets.json /etc/gitlab/gitlab-secrets.json 2>/dev/null || true"
  tags: secrets

- name: Reconfigure PgBouncer
  command: gitlab-ctl reconfigure
  register: result
  retries: 1
  until: result is success
  tags: reconfigure

- name: Restart PgBouncer
  command: gitlab-ctl restart
  register: result
  retries: 2
  until: result is success
  tags:
    - reconfigure
    - restart

- name: Copy secrets file to NFS if missing
  shell: "cp -n /etc/gitlab/gitlab-secrets.json {{ gitlab_nfs_path }}"
  tags: secrets
  run_once: true

- name: Create .pgpass file
  command: gitlab-ctl write-pgpass --host 127.0.0.1 --database pgbouncer --hostuser gitlab-consul
  args:
    stdin: "{{ pgbouncer_password }}\n{{ pgbouncer_password }}\n"
    creates: /var/opt/gitlab/postgresql/.pgpass
  tags: reconfigure

# Bug - https://gitlab.com/gitlab-org/omnibus-gitlab/issues/3448
- name: Restart Consul
  command: gitlab-ctl restart consul
  register: result
  retries: 2
  until: result is success
  tags:
    - reconfigure
    - restart

- name: Create skip-auto-reconfigure file
  file:
    path: /etc/gitlab/skip-auto-reconfigure
    state: touch
    mode: u=rw,g=r,o=r

- name: Run Custom Tasks
  block:
    - name: Check if Custom Tasks file exists
      stat:
        path: "{{ pgbouncer_custom_tasks_file }}"
      register: pgbouncer_custom_tasks_file_path
      delegate_to: localhost
      become: false

    - name: Run Custom Tasks
      include_tasks:
        file: "{{ pgbouncer_custom_tasks_file }}"
        apply:
          tags: custom_tasks
      when: pgbouncer_custom_tasks_file_path.stat.exists
  tags: custom_tasks
